#
# Makefile for installing documenation in Open Source Erlang.
#

# Nothing to be done for these
debug opt clean:

release_spec:
	@if test ! -z "$(ERL_MANDIR)" && test -d "$(ERL_MANDIR)"; then \
	   echo "Installing man pages..."; \
	   for d in man3 man4 man6 ; do \
	     if test -d ../man/$${d}; then \
	       for f in `cd ../man/$${d}; echo *` ; do \
	         if test -f "../man/$${d}/$${f}"; then \
	           ${INSTALL_DATA} ../man/$${d}/$${f} \
	                          $(ERL_MANDIR)/$${d}/$${f}$(ERL_MANEXT) ; \
	         fi; \
	       done; \
	     fi;     \
	   done;     \
	 fi
	@echo "Installing html documentation..."
	@test -d $(RELSYSDIR)/doc || $(INSTALL_DIR) $(RELSYSDIR)/doc
	@for d in html tk_html ; do \
	  if test -d ../$$d; then \
	    (cd .. ; tar cf - $$d) | (cd $(RELSYSDIR)/doc; tar xf -) \
	  fi \
	 done
	@for f in ../*.html; do \
	  if test -f $$f; then \
	    $(INSTALL_DATA) $$f $(RELSYSDIR)/doc ; \
	  fi \
	 done
	@for f in ../../*.html; do \
	  if test -f $$f; then \
	    $(INSTALL_DATA) $$f $(RELSYSDIR) ; \
	  fi \
	 done

